#!/usr/bin/perl -w
use strict;

# Bipartite graph generator.
#
# (c) 2008 Daniel E. Severin.

print "gbipartite - Bipartite graph generator\n\n";

sub manual {
	print "Usage: ./gbipartite.pl file.col vertices1 vertices2\n";
	print "vertices may be a value between 3 and 500.\n";
	exit 1;
}

if ($#ARGV < 2) { manual; }

my $file_col = $ARGV[0];
my $vertices1 = $ARGV[1];
my $vertices2 = $ARGV[2];

my $minvertices = 3;
my $maxvertices = 500;

if ($vertices1 < $minvertices || $vertices1 > $maxvertices) { manual; }
if ($vertices2 < $minvertices || $vertices2 > $maxvertices) { manual; }

print "Output file: $file_col\n";
open OUT, '>', $file_col or die "Error creating file: $!";

my $vertices = $vertices1 + $vertices2;
my $edges = 2 * $vertices1 * $vertices2;
print OUT "c File generated with gbipartite script.\n";
print OUT "c Made by Daniel Severin.\n";
print OUT "p edges $vertices $edges\n";

my $v1;
my $v2;
for ($v1 = 1; $v1 <= $vertices1; $v1++) {
	for ($v2 = $vertices1 + 1; $v2 <= $vertices; $v2++) {
		print OUT "e $v1 $v2\n";
		print OUT "e $v2 $v1\n";
	}
}

close OUT;

print "|V| = $vertices, |E| = " . $edges / 2 . ".\n";
print "Ready!\n";
exit 0;
