#!/usr/bin/perl -w
use strict;

# Converts OUT format to DSATUR RES format.
#
# (c) 2008 Daniel E. Severin.

print "out2res - Converts OUT format to DSATUR RES format\n\n";

sub manual {
	print "Usage: ./out2res.pl file.out file.res\n";
	exit 1;
}

if ($#ARGV < 1) { manual; }

my $arch_in = $ARGV[0];
my $arch_out = $ARGV[1];

print "Input file: $arch_in\n";
open IN, '<', $arch_in or die "Error reading $!";
print "Output file: $arch_out\n";
open OUT, '>', $arch_out or die "Error creating $!";

$_ = <IN>;
chomp;
my @datas = split ':', $_;
my $vertices = $datas[0];

my $i;
my $j;
my @pal;
my @col;
my $colors = 0;
for ($i = 1; $i <= $vertices; $i++) {
	$_ = <IN>;
	chomp;
	my $oldcolor = $_;
	my $newcolor;
	my $flag = 0;
	for ($j = 1; $j <= $colors; $j++) {
		if ($pal[$j] == $oldcolor) {
			$flag = 1;
			$newcolor = $j;
		}
	}
	if (!$flag) {
		$colors++;
		$pal[$colors] = $oldcolor;
		$newcolor = $colors;
	}
	$col[$i] = $newcolor;
}

print OUT "CLRS $colors FROM OUT2RES\n";
my $feed = 0;
for ($i = 1; $i <= $vertices; $i++) {
	my $color = $col[$i];
	print OUT " $color";
	$feed++;
	if ($feed == 12) {
		print OUT "\n";
		$feed = 0;
	}
}

close OUT;
close IN;

print "Ready!\n";
exit 0;
