#!/usr/bin/perl -w
use strict;

# Converts OUT format to a solution.
#
# (c) 2010 Daniel E. Severin.

print "out2sol - Converts OUT format to a solution\n\n";

sub manual {
	print "Usage: ./out2sol.pl file.out file.sol\n";
	exit 1;
}

if ($#ARGV < 1) { manual; }

my $arch_in = $ARGV[0];
my $arch_out = $ARGV[1];

print "Input file: $arch_in\n";
open IN, '<', $arch_in or die "Error reading $!";
print "Output file: $arch_out\n";
open OUT, '>', $arch_out or die "Error creating $!";

$_ = <IN>;
chomp;
my @datas = split ':', $_;
my $vertices = $datas[0];

my $i;
my $j;
for ($i = 1; $i <= $vertices; $i++) {
	$_ = <IN>;
	chomp;
	my $color = $_;
        print OUT " val$i: x" . $i . '_' . $color . " = 1\n";
}

close OUT;
close IN;

print "Ready!\n";
exit 0;
