#!/usr/bin/perl -w
use strict;

# (c) 2010 Daniel E. Severin.
# In UTF-8 unicode.
#
# REQUIRES PORTA SOFTWARE!

sub manual {
	print "Usage: ./poi2dim file\n";
	print "Reads file.poi and computes dimension in file.dim\n";
	exit 1;
}

if ($#ARGV < 0) { manual; }

my $file_poi = $ARGV[0] . ".poi";
my $file_porta = $ARGV[0] . ".porta";
my $file_dim = $ARGV[0] . ".dim";

open IN, '<', $file_poi or die "Error reading $file_poi: $!";

$_ = <IN>;
chomp;
my @datas = split ' ', $_;
if (($datas[0] ne 'DIM') || ($datas[1] ne '=')) {
	print "Error reading $file_poi in first line.\n";
	exit 1;
}
my $dimension = $datas[2];
my $vertices = (-1 + sqrt(1 + 4*$dimension))/2;
print "Dimension: $dimension ==> Vertices: $vertices\n";
close IN;

if ($^O eq "MSWin32") {
	system("xporta.exe -D $file_poi > $file_porta 2> nul");
}
else {
	system("wine xporta.exe -D $file_poi > $file_porta 2>/dev/null");
}

open IN, '<', $file_porta or die "Error reading $file_porta: $!";
open OUT, '>', $file_dim or die "Error creating $file_dim: $!";

my $i;
my $j;
my $index;
my $restr = 1;

print OUT "\nMinimize\n z:";
for ($j = 1; $j <= $vertices; $j++) {
	print OUT " w($j)";
	if ($j < $vertices) { print OUT ' +'; }
}
print OUT "\n\nSubject To\n";

my $flag = 0;

while (<IN>) {
	chomp;
	my $entry = $_;
	if ($entry =~ /sorting/) {
		$flag = 1;
	}
	if ($flag == 1) {
		@datas = split /\051/, $entry;
		if (defined $datas[1]) {
			my $linea = $datas[1];
			$linea =~ s/==/=/;
			# add spaces in to order to not confuse "x1" with "x10" for example
			$linea =~ s/\053/ \053 /g;
			$linea =~ s/\055/ \055 /g;
			for ($i = 1; $i <= $vertices; $i++) {
				for ($j = 1; $j <= $vertices; $j++) {
					$index = ($i-1)*$vertices + ($j-1) + 1;
					$linea =~ s/x$index /x\($i\,$j\)/g;
				}
			}
			for ($j = 1; $j <= $vertices; $j++) {
				$index = $vertices*$vertices + $j;
				$linea =~ s/x$index /w\($j\)/g;
			}
			$linea =~ s/\040//g;
			$linea =~ s/\053/ \053 /g;
			$linea =~ s/\055/ \055 /g;
			$linea =~ s/\)=/\) = /;
			print OUT " s$restr:$linea\n";
			$restr++;
		}
	}
}
print OUT "\nBounds\n";
for ($i = 1; $i <= $vertices; $i++) {
	for ($j = 1; $j <= $vertices; $j++) {
		print OUT " x($i,$j) free\n";
	}
}
for ($j = 1; $j <= $vertices; $j++) {
	print OUT " w$j free\n";
}
print OUT "\nEnd\n";
close OUT;
close IN;

unlink $file_porta;

print "Ready.\n";
exit 0;
